// ====================================================================
// Copyright (C) INRIA -  Serge Steer, Allan CORNET
// 
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at    
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================
path=get_absolute_file_path('builder_fortran.sce');

files=['aind.o'; 'anfm01.o'; 'anfm02.o'; 'anfm03.o'; 'anfm04.o'; 
       'anfm05.o'; 'anfm06.o'; 'anrs01.o'; 'anrs02.o'; 'aux003.o'; 
       'auxo01.o'; 'desr03.o'; 'dimp03.o'; 'dipvtf.o'; 'dnrm0.o'; 
       'nvkt03.o'; 'optr01.o'; 'optr03.o'; 'opvf03.o'; 'pasr03.o'; 
       'plcbas.o'; 'tol03.o';  'zthz.o'];
if newest(path+['date_build';'builder_fortran.sce';strsubst(files,'.o','.f')])==1 then
  clear path files 
  return
end
try
  tbx_build_src(['pclbas'], files, 'f',path);
  mputl(sci2exp(getdate()),path+'date_build')
catch
  mprintf("%s\n",lasterror())
end

clear tbx_build_src path sci2exp files;
